# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import glob
import zipfile




def update_package():
    # Declaring local variables
    package_updated = False
    
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()

    download_url= 'https://www.nirsoft.net/utils/folderchangesview.zip'
    latest_bin = download_url.split('/')[-1]
    #version
    response =requests.get("https://www.nirsoft.net/utils/folder_changes_view.html",proxies=proxies)
    td_elements= bs_find_all(response.text, "td", proxies=proxies)
    version = None
    # Parcourir les éléments pour trouver la version
    full_version_text = None
    version_number = None

    for td in td_elements:
        text = td.get_text().strip()
        if "FolderChangesView v" in text:
            # Extraire la partie contenant "CSVFileView vX.XX"
            full_version_text = text.split(" - ")[0]  # 
            
            # Extraire seulement le numéro de version
            version_number = full_version_text.split("v")[1].rsplit(' ')[0] # 
            break
    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
        package_updated = True
    else:
        print("Binary is present: %s" % latest_bin)


    # Deleting outdated binaries
    for f in glob.glob('*.zip'):
        if f != latest_bin:
            remove_file(f)

    # Extracting the downloaded zip file
    with zipfile.ZipFile(latest_bin, 'r') as zip_ref:
        zip_ref.extractall()
    
    file_list = zip_ref.namelist()
    for filename in file_list :
        if latest_bin.endswith('.exe') :
            zip_ref.extract(latest_bin)
    # Mettre à jour le package
    control.set_software_version(version_number)
    control.save_control_to_wapt()    
        

